##
##  ferret.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2023 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg  0.16.7
%define       V_dist  20230618

#   package information
Name:         ferret
Summary:      Web Scraping Language
URL:          https://github.com/MontFerret/ferret
Vendor:       MontFerret
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Web
License:      MIT
Version:      %{V_opkg}.%{V_dist}
Release:      20230618

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/ferret/ferret-%{V_dist}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Ferret is a web scraping system aiming to simplify data extraction
    from the web for such things like UI testing, machine learning and
    analytics.

%track
    prog ferret:release = {
        version   = %{V_opkg}
        url       = https://github.com/MontFerret/ferret/releases
        regex     = (\d+\.\d+\.\d+)\.tar\.gz
    }
    prog ferret:snapshot = {
        version   = %{V_dist}
        url       = http://download.openpkg.org/components/versioned/ferret/
        regex     = ferret-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n ferret

%build
    #   build program
    export GOPATH=`pwd`
    cd src/github.com/MontFerret/ferret
    go build -v -o ferret .

%install
    #   install program
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    %{l_shtool} install -c -s -m 755 \
        src/github.com/MontFerret/ferret/ferret \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

